#ifndef LSM_STORE_INTERNAL
#define LSM_STORE_INTERNAL

#include <stdio.h>

#include "lsm/store.h"
#include "lsm/str_internal.h"
#include "lsm/trie.h"

typedef struct lsm_attr {
  lsm_attr_type type;
  lsm_str *str;
} lsm_attr;

struct lsm_entry {
  lsm_str *key;
  struct {
    uint64_t count;
    uint64_t bitmap;
    lsm_attr *items;
  } attrs;
  struct {
    uint64_t len;
    union {
      FILE *file;
      char *ptr;
    } value;
    bool on_disk;
  } data;
};

struct lsm_store {
  lsm_trie *trie;
  char *data_path;
  char *db_path;
};

#endif
